Summary:	Single threaded NSCD (Name Service Caching Daemon)
Name:		unscd
Version:	0.51
Release:	1
License:	GPL v2
Group:		Networking/Daemons
Source0:	http://busybox.net/~vda/unscd/nscd-%{version}.c
# Source0-md5:	6e40b96fce1cfb417bd94dbb66086858
Source1:	nscd.init
Source2:	nscd.sysconfig
Source3:	nscd.logrotate
Source4:	nscd.conf
Source5:	http://svn.donarmstrong.com/deb_pkgs/unscd/trunk/debian/nscd.8
# Source5-md5:	eac364084cae21114174404790dfc0df
Source6:	nscd.tmpfiles
URL:		http://busybox.net/~vda/unscd/
BuildRequires:	rpmbuild(macros) >= 1.644
Provides:	group(nscd)
Requires(post):	fileutils
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires:	rc-scripts >= 0.4.1.26
Provides:	user(nscd)
Obsoletes:	gnscd
Obsoletes:	nscd
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# glibc private symbols
%define		_noautoreq		GLIBC_PRIVATE

%description
A daemon which handles passwd, group and host lookups for running
programs and caches the results for the next query. You only need this
package if you are using slow Name Services like LDAP, NIS or NIS+.

This particular NSCD is a complete rewrite of the GNU glibc nscd which
is a single threaded server process which offloads all NSS lookups to
worker children; cache hits are handled by the parent, and only cache
misses start worker children, making the parent immune to resource
leaks, hangs, and crashes in NSS libraries.

It should mostly be a drop-in replacement for existing installs using
nscd.

%prep
%setup -qcT
%{__sed} -ne '/Description:/,/\*\*\*/p' %{SOURCE0} > README

%{__sed} -e '/#define DEBUG_BUILD/ s,^,// ,' %{SOURCE0} > %{name}.c

%build
%{__cc} -o %{name} %{rpmcflags} %{!?debug:-Os} %{rpmcppflags} -DDEBUG_BUILD=0%{?debug:1} %{rpmldflags} -Wall -Wunused-parameter -Wl,--sort-section -Wl,alignment -Wl,--sort-common %{name}.c

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sbindir},%{_mandir}/man8,/var/log,/var/run/nscd,/etc/{logrotate.d,rc.d/init.d,sysconfig},%{systemdtmpfilesdir}}
install -p %{name} $RPM_BUILD_ROOT%{_sbindir}/nscd
install -p %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/nscd
cp -p %{SOURCE5} $RPM_BUILD_ROOT%{_mandir}/man8
cp -p %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/nscd
cp -p %{SOURCE3} $RPM_BUILD_ROOT/etc/logrotate.d/nscd
cp -p %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}
cp -p %{SOURCE6} $RPM_BUILD_ROOT%{systemdtmpfilesdir}/nscd.conf
: > $RPM_BUILD_ROOT/var/log/nscd

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -P nscd -g 144 -r nscd
%useradd -P nscd -u 144 -r -d /tmp -s /bin/false -c "Name Service Cache Daemon" -g nscd nscd

%post
if [ ! -f /var/log/nscd ]; then
	umask 027
	touch /var/log/nscd
	chown root:root /var/log/nscd
	chmod 640 /var/log/nscd
fi
/sbin/chkconfig --add nscd
%service nscd restart "Name Service Cache Daemon"

%preun
if [ "$1" = "0" ]; then
	%service nscd stop
	/sbin/chkconfig --del nscd
fi

%postun
if [ "$1" = "0" ]; then
	%userremove nscd
	%groupremove nscd
fi

%files
%defattr(644,root,root,755)
%doc README
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/nscd
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/nscd.conf
%attr(754,root,root) /etc/rc.d/init.d/nscd
%attr(755,root,root) %{_sbindir}/nscd
%{_mandir}/man8/nscd.8*
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/logrotate.d/nscd
%attr(640,root,root) %ghost /var/log/nscd
%{systemdtmpfilesdir}/nscd.conf
%dir /var/run/nscd
%changelog
* Mon Oct 21 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/unscd.git;a=log;h=master

* Mon Oct 21 2013 Elan Ruusamäe <glen@delfi.ee> 3f80cff
- up to 0.51: fix a case where we forget to refcount-- the cached entry

* Mon Oct 21 2013 Elan Ruusamäe <glen@delfi.ee> 360053e
- up to 0.50: add more files to watch for changes

* Sun Sep 29 2013 Elan Ruusamäe <glen@delfi.ee> 0ed3656
- rpm5 regex fix

* Sun Sep 29 2013 Elan Ruusamäe <glen@delfi.ee> 8e00455
- release 4 (by relup.sh)

* Thu Sep 12 2013 Elan Ruusamäe <glen@delfi.ee> 6835b93
- rel 3

* Thu Sep 12 2013 Elan Ruusamäe <glen@delfi.ee> 8ad0077
- fix formatting

* Thu Sep 12 2013 Elan Ruusamäe <glen@delfi.ee> 8b201f8
- remove unsupported options, document those

* Thu Sep 12 2013 Elan Ruusamäe <glen@delfi.ee> fce3c95
- rel 2

* Tue May 28 2013 Elan Ruusamäe <glen@delfi.ee> 6bebef3
- check status once

* Tue Sep 04 2012 Elan Ruusamäe <glen@delfi.ee> 3ec8870
- allow debug build (via rpmbuild -debug), defaults off now

* Tue Sep 04 2012 Elan Ruusamäe <glen@delfi.ee> f87ccbf
- add pidfile to status

* Tue Sep 04 2012 Elan Ruusamäe <glen@delfi.ee> 46b8b81
- up to 0.49: minor tweaks to messages

* Tue Sep 04 2012 Elan Ruusamäe <glen@delfi.ee> 5c1495e
- Obsoletes gnscd

* Tue Sep 04 2012 Elan Ruusamäe <glen@delfi.ee> 6a339a0
- unify

* Tue Sep 04 2012 Elan Ruusamäe <glen@delfi.ee> ad894a1
- fix force-reload

* Fri Feb 03 2012 Elan Ruusamäe <glen@pld-linux.org> 56b4846
- don't require GLIBC_PRIVATE symbols

* Thu Feb 02 2012 Elan Ruusamäe <glen@pld-linux.org> 96a75a8
- stole nscd.tmpfiles from glibc

* Thu Feb 02 2012 Elan Ruusamäe <glen@pld-linux.org> 113d407
- hack to skip tmpfiles blocker

* Thu Feb 02 2012 Elan Ruusamäe <glen@pld-linux.org> 5e377ee
- release 2

* Tue Jan 31 2012 Jan Rękorajski <baggins@pld-linux.org> 2c1a175
- use proper file name

